package de.micka.lebenshilfe;

import android.content.Context;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.sqlite.SQLiteDatabase;


public class EintraegeDataManager extends SQLiteOpenHelper implements Constants
{
	private static final String DATABASE_NAME = "de.micka.lebenshilfe.haushaltsbuchdb";
    private static final int DATABASE_VERSION = 1;
    	
    /** Create a helper object for the database */
    public EintraegeDataManager(Context ctx) 
    { 
       super(ctx, DATABASE_NAME, null, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db) 
    { 
       db.execSQL("CREATE TABLE " + EINTRAEGE_TABLE_NAME + " (" 
    		 + _ID + " INTEGER PRIMARY KEY AUTOINCREMENT, "  
             + DAY +" INTEGER, "
             + MONTH + " INTEGER, "
             + YEAR + " INTEGER, "
             + CATEGORY + " TEXT NOT NULL, "
             + AMOUNT + " INTEGER, "
             + LISTID + " INTEGER);"
           );
    }
    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) 
    {
       db.execSQL("DROP TABLE IF EXISTS " + EINTRAEGE_TABLE_NAME);
       onCreate(db);
    }
}
