package de.micka.lebenshilfe;

import java.util.Calendar;
import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.DatePicker.OnDateChangedListener;

public class EintragAendern extends Activity implements Constants
{
	
	private EintraegeDataManager eintraege;
	public static String LISTENID ="listenId";
	public static String LISTENTYPEXTRA = "listentyp";
	private String listenname;
	private long listenid;
	private String listentyp;
	private final static String tag="ensacom"; 
	private long id;
	private SQLiteDatabase myDB = null;
	private Eintrag eintrag = new Eintrag();
	DatePicker datePicker;
	private Calendar c = Calendar.getInstance();
	private ArrayAdapter <CharSequence> zweckSpinnerAdapter;
	private Button changeDate;
	static final int DATE_DIALOG_ID = 999;
	private TextView datumGewaehlt;
	public static final int beenden_ID = Menu.FIRST;
	/*	private int year;
	private int month;
	private int day;*/

	public void onCreate(Bundle savedInstanceState) 
	{
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eintragaendernlayout);
        datumGewaehlt = (TextView) findViewById(R.id.txt_aendernGewaehltDatum);
        //Extras Abrufen um ber Spinner Item zu entscheiden
    	extrasAbrufen();
    	Spinner zweckSpinner = (Spinner) findViewById(R.id.aendern_zweck);
    	zweckSpinnerAdapter =  new ArrayAdapter <CharSequence> (this, android.R.layout.simple_spinner_item );
    	zweckSpinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    	if(listentyp.equals("taschengeld"))
    	{
    		zweckSpinnerAdapter.add("Einnahmen");
    		zweckSpinnerAdapter.add("Zigaretten");
    		zweckSpinnerAdapter.add("Ses/Essen");
    		zweckSpinnerAdapter.add("Kino");
    		zweckSpinnerAdapter.add("Schwimmen");
    		zweckSpinnerAdapter.add("Zeitung");
    		zweckSpinnerAdapter.add("Anschaffung");
    		zweckSpinner.setAdapter(zweckSpinnerAdapter);
    	}else if(listentyp.equals("wirtschaftsgeld"))
    	{
    		zweckSpinnerAdapter.add("Einnahmen");
    		zweckSpinnerAdapter.add("Lebensmittel");
    		zweckSpinnerAdapter.add("Hygiene");
    		zweckSpinnerAdapter.add("Sonstiges");
    		zweckSpinner.setAdapter(zweckSpinnerAdapter);
    	}
    	addListenerOnButton();
        altenEintragLaden();
    }
	@Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) 
        {
        	extrasAbrufen();
        	Intent i = new Intent(this, ListenAnsicht.class);;
            i.putExtra(LISTENID, listenid);
        	i.putExtra(LISTENTYPEXTRA, listentyp);
            finish();
            startActivity(i);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
	public void extrasAbrufen()
	{
		final Bundle extras = getIntent().getExtras();
	    if(extras != null)
	    {
	    	listenid = extras.getLong(ListenAnsicht.LISTENID);
	    	this.id = extras.getLong(ListenAnsicht.ID);
	    	listentyp = extras.getString(ListenAnsicht.LISTENTYPEXTRA);
	    }
	}
	public void altenEintragLaden()
	{
		extrasAbrufen();
	    eintrag = null;
	    SQLiteDatabase db = eintraege.getReadableDatabase();
	    Cursor eintragCursor = db.rawQuery("SELECT _ID, DAY, MONTH,  YEAR, CATEGORY, AMOUNT FROM " + EINTRAEGE_TABLE_NAME + " WHERE _ID=" + id , null);
	    eintragCursor.moveToFirst();
	   	if(eintragCursor.moveToFirst())
		{
	   		//							  _id					day						dayid					month					monthid						year					yearid						wofuer					betrag
			//eintrag = new Eintrag(eintragCursor.getInt(0),eintragCursor.getInt(1),eintragCursor.getInt(2),eintragCursor.getInt(3), eintragCursor.getInt(4), eintragCursor.getInt(5), eintragCursor.getInt(6), eintragCursor.getString(7),eintragCursor.getDouble(8));
			//								id							day					month				year					wofuer					betrag
			eintrag = new Eintrag(eintragCursor.getInt(0),eintragCursor.getInt(1),eintragCursor.getInt(2),eintragCursor.getInt(3),eintragCursor.getString(4),eintragCursor.getDouble(5));
		}
	   	eintragCursor.close();
		db.close();
		if(eintrag != null)
		{
			Log.v(tag, "old Eintrag: " + eintrag.day + "." +eintrag.month +"." + eintrag.year +", " + eintrag.wofuer + ", " + eintrag.betrag + ", id=" + eintrag._id + " Listenname: " + listenname);
			datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
			Spinner wofuer = (Spinner)findViewById(R.id.aendern_zweck);
		 	ArrayAdapter myAdap = (ArrayAdapter) wofuer.getAdapter();
		 	int spinnerPosition = myAdap.getPosition(eintrag.wofuer);
		 	wofuer.setSelection(spinnerPosition);
		 	EditText betrag = (EditText)findViewById(R.id.aendern_betrag);
		 	betrag.setText(String.valueOf(eintrag.betrag));
		}
	}
	public void onClickDatum(View v)
    {
    	Button heute = (Button) findViewById(R.id.btn_aendern_Datumheute);
    	Button gestern = (Button) findViewById(R.id.btn_aendern_DatumGestern);
    	
    	if(v == heute)
    	{
    		c = Calendar.getInstance();
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year) + "(heute)");
    	}else if(v == gestern)
    	{
    		c = Calendar.getInstance();
    		c.add(Calendar.DATE, -1);
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year)+ " (gestern)");
    	}
    }
	public void addListenerOnButton() {
		 
		changeDate = (Button) findViewById(R.id.btnAendernChangeDate);
 
		changeDate.setOnClickListener(new OnClickListener() {
 
			public void onClick(View v) {
 
				showDialog(DATE_DIALOG_ID);
 
			}
 
		});
 
	}
	@Override
	protected Dialog onCreateDialog(int id) {
		switch (id) {
		case DATE_DIALOG_ID:
		   return new DatePickerDialog(this, datePickerListener, 
                         eintrag.year, eintrag.month-1,eintrag.day);
		}
		return null;
	}
	private DatePickerDialog.OnDateSetListener datePickerListener 
                = new DatePickerDialog.OnDateSetListener() {
 
		// when dialog box is closed, below method will be called.
		public void onDateSet(DatePicker view, int selectedYear,
				int selectedMonth, int selectedDay) {
			eintrag.year = selectedYear;
			eintrag.month = selectedMonth+1;
			eintrag.day = selectedDay;
 
			// set selected date into textview
			datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
 
 
		}
	};
	public void onClickEintragSpeichern(View view ) 
    {
		Spinner wofuer = (Spinner) findViewById(R.id.aendern_zweck);
    	EditText betrag = (EditText) findViewById(R.id.aendern_betrag);
    	SQLiteDatabase db = eintraege.getWritableDatabase();
    	eintrag.wofuer = wofuer.getSelectedItem().toString();
    	try{
    		eintrag.betrag = Double.parseDouble(betrag.getText().toString());
        	db.execSQL("INSERT INTO " + EINTRAEGE_TABLE_NAME +" (DAY, MONTH, YEAR, CATEGPRY, AMOUNT, LISTID) "
    				+"VALUES (" + eintrag.day + "," + eintrag.month+ ","
    				+ eintrag.year +", '" + eintrag.wofuer +"' ," + eintrag.betrag +",'" + listenid +"');");
    		db.execSQL("DELETE FROM " + EINTRAEGE_TABLE_NAME+ " WHERE _ID=" + id + ";");
            myDB.close();
    		final Intent i = new Intent(this, ListenAnsicht.class);
    		i.putExtra(LISTENID, listenid);
    		i.putExtra(LISTENTYPEXTRA, listentyp);
            finish();
            startActivity(i);
    	}catch (NumberFormatException e)
    	{
    		Toast msg = Toast.makeText(EintragAendern.this, "Sie haben keinen Betrag eingegeben", Toast.LENGTH_LONG);
    		msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);
    		msg.show();
    	}
    	
    }
	@Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
    	getMenuInflater().inflate(R.menu.optionsmenu, menu);
		return super.onCreateOptionsMenu(menu);
    }
    public boolean onOptionsItemSelected(MenuItem item)
    {//Was passiert wenn ein Options-Men Eintrag gewhlt wird
    	switch(item.getItemId())
    	{
    		case R.id.opt_beenden: 
    			System.exit(0);
    		case R.id.opt_zurUebersicht:
    		{
    			final Intent intent = new Intent(this, ListenUebersicht.class);
    			startActivity(intent);
    		};
    		default:
    			return super.onOptionsItemSelected(item);
    	}
    }
}
