package de.micka.lebenshilfe;

import java.util.Calendar;
import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.ContentValues;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.DatePicker.OnDateChangedListener;



public class EintragHinzufuegen extends Activity implements Constants
{
	private ListenDataManager listen;
	private EintraegeDataManager eintraege;
	public static String LISTENID ="listenId";
	public static String LISTENTYPEXTRA ="listentyp";
	private String listenname;
	private long listenid;
	private String listentyp;
	private boolean neueListe =  false;
	/** Erzeugt Meneintrag beenden **/
    public static final int beenden_ID = Menu.FIRST;
	final Eintrag eintrag = new Eintrag();
	private Calendar c = Calendar.getInstance();
	private ArrayAdapter <CharSequence> zweckSpinnerAdapter;
	private Button changeDate;
	static final int DATE_DIALOG_ID = 999;
/*	private int year;
	private int month;
	private int day;*/
	private TextView datumGewaehlt;
	 

	public void onCreate(Bundle savedInstanceState) 
	{
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eintraghinzufuegenlayout);
        eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    	eintrag.month = c.get(Calendar.MONTH) + 1;
    	eintrag.year = c.get(Calendar.YEAR);
    	datumGewaehlt = (TextView) findViewById(R.id.txtGewaehltDatum);
    	datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year) + " (heute)");
    	//Extras Abrufen um ber Spinner Item zu entscheiden
    	extrasAbrufen();
    	Spinner zweckSpinner = (Spinner) findViewById(R.id.hinzufuegen_zweck);
    	zweckSpinnerAdapter =  new ArrayAdapter <CharSequence> (this, android.R.layout.simple_spinner_item );
    	zweckSpinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    	if(listentyp.equals("taschengeld"))
    	{
    		zweckSpinnerAdapter.add("Einnahmen");
    		zweckSpinnerAdapter.add("Zigaretten");
    		zweckSpinnerAdapter.add("Ses/Essen");
    		zweckSpinnerAdapter.add("Kino");
    		zweckSpinnerAdapter.add("Schwimmen");
    		zweckSpinnerAdapter.add("Zeitung");
    		zweckSpinnerAdapter.add("Anschaffung");
    		zweckSpinner.setAdapter(zweckSpinnerAdapter);
    	}else if(listentyp.equals("wirtschaftsgeld"))
    	{
    		zweckSpinnerAdapter.add("Einnahmen");
    		zweckSpinnerAdapter.add("Lebensmittel");
    		zweckSpinnerAdapter.add("Hygiene");
    		zweckSpinnerAdapter.add("Sonstiges");
    		zweckSpinner.setAdapter(zweckSpinnerAdapter);
    	}
    	addListenerOnButton();
    }
	public void addListenerOnButton() {
		 
		changeDate = (Button) findViewById(R.id.btnChangeDate);
 
		changeDate.setOnClickListener(new OnClickListener() {
 
			public void onClick(View v) {
 
				showDialog(DATE_DIALOG_ID);
 
			}
 
		});
 
	}
	@Override
	protected Dialog onCreateDialog(int id) {
		switch (id) {
		case DATE_DIALOG_ID:
		   // set date picker as current date
			eintrag.year = c.get(Calendar.YEAR);
			eintrag.month = c.get(Calendar.MONTH)+1;
			eintrag.day = c.get(Calendar.DAY_OF_MONTH);
			
		   return new DatePickerDialog(this, datePickerListener, 
                         eintrag.year, eintrag.month-1,eintrag.day);
		}
		return null;
	}
 
	private DatePickerDialog.OnDateSetListener datePickerListener 
                = new DatePickerDialog.OnDateSetListener() {
 
		// when dialog box is closed, below method will be called.
		public void onDateSet(DatePicker view, int selectedYear,
				int selectedMonth, int selectedDay) {
			eintrag.year = selectedYear;
			eintrag.month = selectedMonth+1;
			eintrag.day = selectedDay;
 
			// set selected date into textview
			datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
 
 
		}
	};
	@Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) 
        {
        	extrasAbrufen();
        	if(neueListe)
        	{
        		Intent i = new Intent(this, ListenUebersicht.class);;
            	finish();
                startActivity(i);
                return true;
        	}else
        	{
        		Intent i = new Intent(this, ListenAnsicht.class);;
            	i.putExtra(LISTENID, listenid);
        		i.putExtra(LISTENTYPEXTRA, listentyp);
            	finish();
                startActivity(i);
                return true;
        	}
        }
        return super.onKeyDown(keyCode, event);
    }
	@Override
	public boolean onCreateOptionsMenu(Menu menu)
    {
    	getMenuInflater().inflate(R.menu.optionsmenu, menu);
		return super.onCreateOptionsMenu(menu);
    }
    public boolean onOptionsItemSelected(MenuItem item)
    {//Was passiert wenn ein Options-Men Eintrag gewhlt wird
    	switch(item.getItemId())
    	{
    		case R.id.opt_beenden: 
    			System.exit(0);
    		case R.id.opt_zurUebersicht:
    		{
    			final Intent intent = new Intent(this, ListenUebersicht.class);
    			startActivity(intent);
    		};
    		default:
    			return super.onOptionsItemSelected(item);
    	}
    }
    public void onClickDatum(View v)
    {
    	Button heute = (Button) findViewById(R.id.btnDatumheute);
    	Button gestern = (Button) findViewById(R.id.btnDatumGestern);
    	   	
    	
    	if(v == heute)
    	{
    		c = Calendar.getInstance();
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		//datePicker.updateDate(eintrag.year, eintrag.month -1, eintrag.day);
    		datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year)+ " (heute)");
    	}else if(v == gestern)
    	{
    		c = Calendar.getInstance();
    		c.add(Calendar.DATE, -1);
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		//datePicker.updateDate(eintrag.year, eintrag.month -1, eintrag.day);
    		datumGewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year)+ " (gestern)");
    	}
    	
    }
    public void extrasAbrufen()
    {
    	final Bundle extras = this.getIntent().getExtras();
    	listentyp = "bla";
    	if(extras != null)
    	{
    		listentyp = extras.getString(ListenUebersicht.LISTENTYPEXTRA);
    		neueListe = extras.getBoolean(ListenUebersicht.NEUELISTE);
    		listenname = extras.getString(ListenUebersicht.LISTENNAME);
    		if(listentyp == null)
    		{
    			listenid = extras.getLong(ListenAnsicht.LISTENID);
    			listentyp = extras.getString(ListenAnsicht.LISTENTYPEXTRA);
    		}
    	}
    }
    public void onClickEintragSpeichern(final View sfNormal) 
    {	
    	extrasAbrufen();
    	listen = new ListenDataManager(this);
    	SQLiteDatabase db = listen.getWritableDatabase();
    	if(neueListe)
    	{
    		/*db.execSQL("INSERT INTO " + LISTEN_TABLE_NAME +" (LISTENNAME, LISTENTYP) "
    				+"VALUES ('" + listenname + "', '" + listentyp + "');");*/
    		ContentValues values = new ContentValues();
    		values.put(LISTENNAME, listenname);
    		values.put(LISTENTYP, listentyp);
    		// Insert a new record
    		db.insertOrThrow(LISTEN_TABLE_NAME, null, values);
    		
    		Cursor cursor = db.rawQuery("SELECT _ID FROM " + LISTEN_TABLE_NAME + " WHERE LISTENNAME='" + listenname +"'" , null);
    		listenid = cursor.getLong(0);
    		db.close();
    	}
    	eintraege = new EintraegeDataManager(this);
    	Spinner wofuer = (Spinner) findViewById(R.id.hinzufuegen_zweck);
    	EditText betrag = (EditText) findViewById(R.id.hinzufuegen_betrag);
    	boolean betragcheck = false;
    	//Extras abrufen
    	extrasAbrufen();
    	eintrag.wofuer = wofuer.getSelectedItem().toString();
    	try 
    	{
    		eintrag.betrag = Double.parseDouble(betrag.getText().toString());
    		db = eintraege.getWritableDatabase();
    		//SQLiteDatabase db = this.openOrCreateDatabase(EINTRAEGE_TABLE_NAME, MODE_PRIVATE, null);
	        db.execSQL("INSERT INTO " + EINTRAEGE_TABLE_NAME +" (DAY, MONTH, YEAR, CATEGORY, AMOUNT, LISTID) "
    				+"VALUES (" + eintrag.day + "," + eintrag.month+ "," + eintrag.year +", '" + eintrag.wofuer +"' ," + eintrag.betrag +",'" + listenid + "');");
    		//Log.v(tag, "Insert new Eintrag: " + eintrag.day + "." +eintrag.month +"." + eintrag.year +", " + eintrag.wofuer + ", " + eintrag.betrag + ", id=" + eintrag._id + " in Liste: " + listenname);
            db.close();
            final Intent i = new Intent(this, ListenAnsicht.class);
            i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            i.putExtra(LISTENID, listenid);
            i.putExtra(LISTENTYPEXTRA, listentyp);
    		//i.putExtra(GUTHABEN, tabellenGuthaben);
    		finish();
            startActivity(i);
    	}catch(NumberFormatException e)
    	{
    		Toast msg = Toast.makeText(EintragHinzufuegen.this, "Sie haben keinen Betrag eingegeben", Toast.LENGTH_LONG);
    		msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);
    		msg.show();
    	}	
    }
}
