package de.micka.lebenshilfe;

import java.math.BigDecimal;
import java.util.ArrayList;
import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class EintragListAdapter extends BaseAdapter
{
	private ArrayList<Eintrag> mData = new ArrayList<Eintrag>();
    
	private final LayoutInflater mLayoutInflater;

	public EintragListAdapter(Context pContext, ArrayList<Eintrag> pData)
	{
	                mData = pData;
	                
	                mLayoutInflater = (LayoutInflater) pContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}
	//Gibt uns die Anzahl der Elemente in der ArrayList zurck
	public int getCount() 
	{
		return mData.size();
	}
	//Gibt uns das Item an der gewnschten Stelle zurck
	public Object getItem(int pPosition) 
	{
		return mData.get(pPosition);
	}
	//getItemId() gibt normalerweise die Reihen ID zurck, welche mit dem Element an der Position in der ArrayList in Verbindung gebracht wird. Fr unseren Zweck aber uninteressant.
	public long getItemId(int pPosition) 
	{
		Eintrag eintrag = mData.get(pPosition);
		return eintrag._id;
		//return 0;
	}
	public void changeData(ArrayList<Eintrag> pData)
	{
        mData = pData;
        this.notifyDataSetChanged();
	}
	private String genauZweiNachkommastellen(Double zahl)
    {
    	BigDecimal myDec;
    	myDec = new BigDecimal( zahl );
	 	myDec = myDec.setScale( 2, BigDecimal.ROUND_HALF_UP );
	 	String erg = "" + myDec;
	 	System.out.println(erg);
	 	return erg;
    }
	//
	public View getView(int pPosition, View convertView, ViewGroup parent) 
	{
		if (convertView == null) 
		{
			//convertView = mLayoutInflater.inflate(R., null);
            convertView = mLayoutInflater.inflate(R.layout.tabellenansichtlayout, null);
        }
		String datum;
		String day = String.valueOf(((Eintrag)getItem(pPosition)).day);
		String month = String.valueOf(((Eintrag)getItem(pPosition)).month);
		String year = String.valueOf(((Eintrag)getItem(pPosition)).year);
		datum = day + "." + month + "." + year;
		((TextView) convertView.findViewById(R.id.eintraegeAnzeigenDatum)).setText(datum);
		((TextView) convertView.findViewById(R.id.eintraegeAnzeigenZweck)).setText(((Eintrag)getItem(pPosition)).wofuer);
		Double betrag = ((Eintrag)getItem(pPosition)).betrag;
		if(((Eintrag)getItem(pPosition)).wofuer.equals("Einnahmen"))
			((TextView) convertView.findViewById(R.id.eintraegeAnzeigenBetrag)).setTextColor(Color.GREEN);
		else
			((TextView) convertView.findViewById(R.id.eintraegeAnzeigenBetrag)).setTextColor(Color.RED);
		
		((TextView) convertView.findViewById(R.id.eintraegeAnzeigenBetrag)).setText(genauZweiNachkommastellen(betrag) + " ");
		
        return convertView;
	}
	
}
