package de.micka.lebenshilfe;

import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import java.math.BigDecimal;

public class ListenAnsicht extends ListActivity implements Constants
{
	private ListenDataManager listen;
	private EintraegeDataManager eintraege;
	public static String LISTENID ="listenId";
	public static String LISTENTYPEXTRA = "listentyp";
	//private String listenname;
	private long listenid;
	private String listentyp;
	private double rest;
	private double lebensmittel;
	private double hygiene;
	private double sonstiges;
	private double zigaretten;
	private double suessesEssen;
	private double kino;
	private double schwimmen;
	private double zeitung;
	private double anschaffung;
	public static String ID = "-1";
	private SQLiteDatabase myDB;
	private View header;
	private View footer;
	private MenuInflater inflater;
	private ListView listView;
	private AdapterContextMenuInfo info;
	private final static String tag="ensacom"; 
	private EintragListAdapter mAdapter;
    private ArrayList<Eintrag> mData = new ArrayList<Eintrag>();
    private TextView restGuthaben;
    public static final int beenden_ID = Menu.FIRST;
    
    
        
    /** Called when the activity is first created. */
    @Override
	public void onCreate(Bundle savedInstanceState) 
    {
    	super.onCreate(savedInstanceState);
    	extrasAbrufen();
    		
    	mAdapter = new EintragListAdapter(this, mData);
    	
    	if(listentyp.equals("taschengeld"))
    	{
    		footer = getLayoutInflater().inflate(R.layout.ansichttaschengeldfooterlayout, null);
    		TextView txtREST = (TextView) footer.findViewById(R.id.eintraegeAnzeigenTaschengeldRest);
    		txtREST.setTextColor(Color.YELLOW);
    		restGuthaben = (TextView) footer.findViewById(R.id.eintraegeAnzeigenTaschengeldRestWert);
    		
    	}else if(listentyp.equals("wirtschaftsgeld"))
    	{
    		footer = getLayoutInflater().inflate(R.layout.ansichtwirtschaftfooterlayout, null);
    		restGuthaben = (TextView) footer.findViewById(R.id.eintraegeAnzeigenHaushaltRestWert);
    		TextView txtREST = (TextView) footer.findViewById(R.id.eintraegeAnzeigenHaushaltRest);
    		txtREST.setTextColor(Color.YELLOW);
    	}
    	restGuthaben.setTextColor(Color.YELLOW);
    	header = getLayoutInflater().inflate(R.layout.ansichttitellayout, null);
    	listView = getListView();
    	registerForContextMenu(listView);
		listView.addHeaderView(header);
		listView.addFooterView(footer);
		initiateData();
		restGuthaben.setText(genauZweiNachkommastellen(rest) + " ");
		this.setListAdapter(mAdapter);
    }
    public void extrasAbrufen()
    {
    	final Bundle extras = getIntent().getExtras();
    	if(extras != null)
    	{
    		listenid = extras.getLong(ListenUebersicht.LISTENID);
    		listentyp = extras.getString(ListenUebersicht.LISTENTYPEXTRA);
    		if(listenid == 0L)
    		{
    			listenid = extras.getLong(EintragHinzufuegen.LISTENID);
    			listentyp= extras.getString(EintragHinzufuegen.LISTENTYPEXTRA);
    			if(listenid == 0L)
    			{
    				listenid = extras.getLong(EintragAendern.LISTENID);
    				listentyp = extras.getString(EintragAendern.LISTENTYPEXTRA);
    			}
    		}
    	}
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            Intent i = new Intent(this, ListenUebersicht.class);;
            finish();
            startActivity(i);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
                                    ContextMenuInfo menuInfo) {
      super.onCreateContextMenu(menu, v, menuInfo);
      inflater = getMenuInflater();
      inflater.inflate(R.menu.eintragcontext, menu);
    }
    @Override
    public boolean onContextItemSelected(MenuItem item) 
    {
      info = (AdapterContextMenuInfo) item.getMenuInfo();
      switch (item.getItemId()) {
      case R.id.eintrag_context_bearbeiten:
     	  eintragBearbeiten(info.id);
    	  return true;
      case R.id.eintrag_context_loeschen:
    	  eintragLoeschen(info.id);
          return true;
      default:
        return super.onContextItemSelected(item);
      }
    }
    public void onClickEintragHinzufuegen(View v)
    {
    	Intent intent =  new Intent(this, EintragHinzufuegen.class);
    	intent.putExtra(LISTENID, listenid);
    	intent.putExtra(LISTENTYPEXTRA, listentyp);
    	finish();
		startActivity(intent);
    }
    private void eintragLoeschen(long id)
    {
    	SQLiteDatabase db = eintraege.getWritableDatabase();
        try
    	{	
    		db.execSQL("DELETE FROM " + EINTRAEGE_TABLE_NAME + " WHERE _ID=" + id + ";");
    	}catch(SQLException esql)
    	{
    		Log.v(tag, esql.toString());
    	}
    	db.close();
    	final Intent intent = new Intent(this, ListenAnsicht.class);
		intent.putExtra(LISTENID, listenid);
		intent.putExtra(LISTENTYPEXTRA, listentyp);
		finish();
		startActivity(intent);
    }
    public void eintragBearbeiten(long id)
    {
    	Intent intent = new Intent(this, EintragAendern.class);
    	intent.putExtra(ID, id);
    	intent.putExtra(LISTENID, listenid);
    	intent.putExtra(LISTENTYPEXTRA, listentyp);
    	finish();
    	startActivity(intent);
    }
    private String genauZweiNachkommastellen(Double zahl)
    {
    	BigDecimal myDec;
    	myDec = new BigDecimal( zahl );
	 	myDec = myDec.setScale( 2, BigDecimal.ROUND_HALF_UP );
	 	String erg = "" + myDec;
	 	System.out.println(erg);
	 	return erg;
    }
    private void initiateData()
    {
    	rest = 0;
    	lebensmittel = 0;
    	hygiene = 0;
    	sonstiges = 0;
    	zigaretten = 0;
    	suessesEssen = 0;
    	kino = 0;
    	schwimmen = 0;
    	zeitung = 0;
    	anschaffung = 0;
    	Eintrag eintrag;
    	SQLiteDatabase db = eintraege.getWritableDatabase();
    	
   	 	Cursor eintragCursor = db.rawQuery("SELECT _ID, DAY, MONTH, YEAR, CATEGORY, AMOUNT FROM " + EINTRAEGE_TABLE_NAME + " WHERE LISTID = '" + listenid + "' Order By YEAR, MONTH, DAY", null);
   	 	db.close();
   	 	eintragCursor.moveToFirst();   	 	
   	 	if(eintragCursor.moveToFirst())
   	 	{
   	 		do
   	 		{
   	 			eintrag = null;
   	 			//						id								day						month				year					wofuer					betrag
   	 			eintrag = new Eintrag(eintragCursor.getInt(0),eintragCursor.getInt(1),eintragCursor.getInt(2),eintragCursor.getInt(3),eintragCursor.getString(4),eintragCursor.getDouble(5));
   	 			mData.add(eintrag);
   	 			
   	 			eintragCursor.moveToNext();
   	 			if(eintrag.betrag < 0)
   	 				eintrag.betrag = eintrag.betrag * -1;
   	 			if(eintrag.wofuer.equals("Einnahmen"))
   	 			{
   	 				rest = rest + eintrag.betrag;
   	 			}else
   	 			{
   	 				rest = rest - eintrag.betrag;
   	 			}
   	 			if(eintrag.wofuer.equals("Lebensmittel"))
 					lebensmittel = lebensmittel + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Zigaretten"))
   	 				zigaretten = zigaretten + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Hygiene"))
 					hygiene = hygiene + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Sonstiges"))
 					sonstiges = sonstiges + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Ses/Essen"))
   	 				suessesEssen = suessesEssen + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Kino"))
	 				kino = kino + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Schwimmen"))
   	 				schwimmen = schwimmen + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Zeitung"))
   	 				zeitung = zeitung + eintrag.betrag;
   	 			else if(eintrag.wofuer.equals("Anschaffung"))
   	 				anschaffung = anschaffung + eintrag.betrag;
   	 		}while(eintragCursor.isAfterLast() == false);	
   	 	}
   	 	eintragCursor.close();
   	 	if(listentyp.equals("taschengeld"))
   	 	{
   	 		TextView txtZigaretten = (TextView) findViewById(R.id.eintraegeAnzeigenZigarettenWert);
   	 		txtZigaretten.setText(genauZweiNachkommastellen(zigaretten) + " ");
   	 		TextView txtSuessesEssen = (TextView) findViewById(R.id.eintraegeAnzeigenSuessesEssenWert);
   	 		txtSuessesEssen.setText(genauZweiNachkommastellen(suessesEssen) + " ");
   	 		TextView txtKino = (TextView) findViewById(R.id.eintraegeAnzeigenKinoWert);
	 		txtKino.setText(genauZweiNachkommastellen(kino) + " ");
   	 		TextView txtSchwimmen = (TextView) findViewById(R.id.eintraegeAnzeigenSchwimmenWert);
   	 		txtSchwimmen.setText(genauZweiNachkommastellen(schwimmen) + " ");
   	 		TextView txtZeitung = (TextView) findViewById(R.id.eintraegeAnzeigenZeitungWert);
	 		txtZeitung.setText(genauZweiNachkommastellen(zeitung) + " ");
	 		TextView txtAnschaffung = (TextView) findViewById(R.id.eintraegeAnzeigenAnschaffungWert);
   	 		txtAnschaffung.setText(genauZweiNachkommastellen(anschaffung) + " ");
   	 		TextView txtRest = (TextView) findViewById(R.id.eintraegeAnzeigenTaschengeldRestWert);
	 		txtRest.setText(genauZweiNachkommastellen(rest) + " ");
   	 	}else if(listentyp.equals("wirtschaftsgeld"))
   	 	{
   	 		TextView txtLebensmittel = (TextView) findViewById(R.id.eintraegeAnzeigenLebensmittelWert);
	 		txtLebensmittel.setText(genauZweiNachkommastellen(lebensmittel) + " ");
	 		TextView txtHygiene = (TextView) findViewById(R.id.eintraegeAnzeigenHygieneWert);
   	 		txtHygiene.setText(genauZweiNachkommastellen(hygiene) + " ");
   	 		TextView txtSonstiges = (TextView) findViewById(R.id.eintraegeAnzeigenSonstigesWert);
	 		txtSonstiges.setText(genauZweiNachkommastellen(sonstiges) + " ");
	 		TextView txtRest = (TextView) findViewById(R.id.eintraegeAnzeigenHaushaltRestWert);
   	 		txtRest.setText(genauZweiNachkommastellen(rest) + " ");
   	 	}
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
    	getMenuInflater().inflate(R.menu.optionsmenu, menu);
		return super.onCreateOptionsMenu(menu);
    }
    public boolean onOptionsItemSelected(MenuItem item)
    {//Was passiert wenn ein Options-Men Eintrag gewhlt wird
    	switch(item.getItemId())
    	{
    		case R.id.opt_beenden: 
    			System.exit(0);
    		case R.id.opt_zurUebersicht:
    		{
    			final Intent intent = new Intent(this, ListenUebersicht.class);
    			startActivity(intent);
    		};
    		default:
    			return super.onOptionsItemSelected(item);
    	}
    }
}
