package de.micka.lebenshilfe;


import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.Toast;

public class ListenUebersicht extends ListActivity implements Constants {
    
	private ListenDataManager listen;
	private EintraegeDataManager eintraege;
	private Tabelle tabelle;
	public static String LISTENID ="listenId";
	public static String LISTENNAME ="listenname";
	public static String LISTENTYPEXTRA = "listentyp";
	public static String NEUELISTE = "neueListe";
	public static final String ID = "id";
	private String listenname;
	private long listenid;
	private String listentyp;
	private View header = null;
	private ListView listView = null;
	private TabelleListAdapter mAdapter;
    private ArrayList<Tabelle> mData = new ArrayList<Tabelle>();
    private Cursor tabelleCursor = null;
    private MenuInflater inflater;
    private AdapterContextMenuInfo info;
    private TextView txtview = null;
    private EditText newTable = null;
    private boolean neueListe = false;
	
	/** Called when the activity is first created. */
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        //initiateDatabase(); //Datenbank initialisieren
    	initiateData();		//Array-List fr Listview fllen
    	mAdapter = new TabelleListAdapter(this, mData);
    	header = getLayoutInflater().inflate(R.layout.uebersichttitellayout, null);
    	listView = getListView();
    	registerForContextMenu(listView);
		listView.addHeaderView(header);
    	this.setListAdapter(mAdapter);
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            finish();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    private void tabelleLoeschen(long id)
    {
    	SQLiteDatabase db = listen.getWritableDatabase();
    	db.execSQL("DELETE FROM " + LISTEN_TABLE_NAME + " WHERE LISTID = '" + id + "';");
    	db.close();
    	db = eintraege.getWritableDatabase();
    	db.execSQL("DELETE FROM" + EINTRAEGE_TABLE_NAME + " WHERE LISTID = '" + id + "';");
    	db.close();
    	final Intent intent = new Intent(this, ListenUebersicht.class);
		finish();
		startActivity(intent);
    }
    public void tabelleBearbeiten(long tabid)
    {
    	
   	 	final Intent intent = new Intent(this, TabelleBearbeiten.class);
   	 	intent.putExtra(LISTENID, listenid);
   	 	intent.putExtra(LISTENNAME, listenname);
   	 	intent.putExtra(LISTENTYPEXTRA, listentyp);
   	 	finish();
		startActivity(intent);
    }
    public void onCreateContextMenu(ContextMenu menu, View v,ContextMenuInfo menuInfo) 
    {
    	super.onCreateContextMenu(menu, v, menuInfo);
    	inflater = getMenuInflater();
    	inflater.inflate(R.menu.tabellecontext, menu);
    }
    public boolean onContextItemSelected(MenuItem item) 
    {
      info = (AdapterContextMenuInfo) item.getMenuInfo();
      switch (item.getItemId()) {
      case R.id.tabelle_context_bearbeiten:
    	  tabelleBearbeiten(info.id);
     	  //Log.v(tag, mData.get(info.position-1).tabellenname);
    	  return true;
      case R.id.tabelle_context_loeschen:
    	  tabelleLoeschen(info.id);
          return true;
      default:
        return super.onContextItemSelected(item);
      }
    }    
    private void initiateData()
    {
    	Log.i("Listenbersicht","initiate Data ");
        listen = new ListenDataManager(this);
  	  	try {
      	  SQLiteDatabase db = listen.getReadableDatabase();
      	  Cursor cursor = db.rawQuery("SELECT DISTINCT listenname FROM "+ LISTEN_TABLE_NAME + " Order By listenname", null);
      	  startManagingCursor(cursor);
      	  	if(cursor.moveToFirst())
      	  	{
      	  		do
      	  		{
      	  			tabelle = null;
      	  			cursor.moveToFirst();
      	  			tabelle = new Tabelle(cursor.getInt(0),cursor.getString(1));
      	  			mData.add(tabelle);
      	  			cursor.moveToNext();
      	  		}while(cursor.isAfterLast() == false);
      	  	}
      	  db.close();
        } finally {
           listen.close(); 
        }
    }
    public void onClickTabelleAnzeigen(View view)
    {
    	txtview = (TextView) view;
    	//Neue Activity
    	final Intent intent = new Intent(this, ListenAnsicht.class);
    	//zu bergebene Werte setzen
		listenid = (long) txtview.getId();
		try {
			SQLiteDatabase db = listen.getReadableDatabase();
	      	Cursor cursor = db.rawQuery("SELECT DISTINCT listentyp FROM "+ LISTEN_TABLE_NAME + " WHERE _ID = '" + listenid +"'", null);
	      	startManagingCursor(cursor);
	      		if(cursor.moveToFirst())
	      	  	{
	      	  		cursor.moveToFirst();
	      	  		listentyp = cursor.getString(0);
	      	  	}
	      	db.close();
	        } finally {
	           listen.close(); 
	        }
		//Extras bergeben
		intent.putExtra(LISTENID, listenid);
		intent.putExtra(LISTENTYPEXTRA, listentyp);
		finish();
		startActivity(intent);
    }
    public void onClickTabelleHinzufuegen(View view)
    {
    	newTable = null;
    	newTable = (EditText) findViewById(R.id.edt_liste_name);
    	RadioGroup radioGroup = (RadioGroup) findViewById(R.id.radiogroup_tabellentyp);
    	int checkedRadioButton = radioGroup.getCheckedRadioButtonId();
    	//Fehlende Eingaben prfen
    	if(newTable.getText().toString().equals(""))//Listenname
    	{
    		Toast msg = Toast.makeText(ListenUebersicht.this, "Sie haben keinen Listennamen eingegeben", Toast.LENGTH_LONG);

    		msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);

    		msg.show();
    	}else if(checkedRadioButton == -1)//Listentyp
    	{
    		Toast msg = Toast.makeText(ListenUebersicht.this, "Sie haben keinen Listentyp gewhlt", Toast.LENGTH_LONG);

    		msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);

    		msg.show();
    	}else//wenn alle Eingaben vorhanden
    	{
    		final Intent intent = new Intent(this, EintragHinzufuegen.class);
    		listenname = newTable.getText().toString();
    		listentyp = "bla";
    		
    		switch (checkedRadioButton) 
    		{
    		case R.id.radioButtonTaschengeld : listentyp = "taschengeld";
    	         break;
    		case R.id.radioButtonWirtschaft : listentyp = "wirtschaftsgeld";
    			 break;
    		}
    		neueListe = true;
    		//intent.putExtra(LISTENID, listenid);
    		intent.putExtra(LISTENNAME, listenname);
    		intent.putExtra(LISTENTYPEXTRA, listentyp);
    		intent.putExtra(NEUELISTE, neueListe);
    		finish();
    		startActivity(intent);
    	}
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
    	getMenuInflater().inflate(R.menu.optionsmenu_listenuebersicht, menu);
    	return super.onCreateOptionsMenu(menu);
    }
    public boolean onOptionsItemSelected(MenuItem item)
    {//Was passiert wenn ein Options-Men Eintrag gewhlt wird
    	switch(item.getItemId())
    	{
    		case R.id.opt_beenden_listenuebersicht: 
    			System.exit(0);
    		default:
    			return super.onOptionsItemSelected(item);
    	}
    }
}