package de.micka.lebenshilfe;

import java.util.ArrayList;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;


public class TabelleListAdapter extends BaseAdapter
{
	private ArrayList<Tabelle> mData = new ArrayList<Tabelle>();
	private final LayoutInflater mLayoutInflater;
	public TabelleListAdapter(Context pContext, ArrayList<Tabelle> pData)
	{
	                mData = pData;
	                
	                mLayoutInflater = (LayoutInflater) pContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}
	//Gibt uns die Anzahl der Elemente in der ArrayList zurck
	public int getCount() 
	{
		return mData.size();
	}
	//Gibt uns das Item an der gewnschten Stelle zurck
	public Object getItem(int pPosition) 
	{
		return mData.get(pPosition);
	}
	//getItemId() gibt normalerweise die Reihen ID zurck, welche mit dem Element an der Position in der ArrayList in Verbindung gebracht wird. Fr unseren Zweck aber uninteressant.
	public long getItemId(int pPosition) 
	{
		Tabelle tab = mData.get(pPosition);
		return tab.id;
	}
	public void changeData(ArrayList<Tabelle> pData)
	{
        mData = pData;
        this.notifyDataSetChanged();
	}
	//
	public View getView(int pPosition, View convertView, ViewGroup parent) 
	{
		if (convertView == null) 
		{
            convertView = mLayoutInflater.inflate(R.layout.tabellenanzeigenlayout, null);
        }
		
		((TextView) convertView.findViewById(R.id.btn_tabelle)).setText(((Tabelle)getItem(pPosition)).listenname);
		((TextView) convertView.findViewById(R.id.btn_tabelle)).setId(((Tabelle)getItem(pPosition)).id);
		
        return convertView;
	}
	
}
